!     $Id: fpcalcnrx.f90,v 1.3 2010/05/11 04:22:28 nuga Exp $
!
! ************************************************************
!
!      CALCULATION OF NONLINEAR-RELAIVISTIC COLLISIONAL OPERATOR
!
! ************************************************************
!
      MODULE fpcalcnr

      USE fpcomm

      PUBLIC FPCALC_NLR


      contains

!-------------------------------------------------------------

      SUBROUTINE FPCALC_NLR(NR,NSB,NSA)

      Implicit none
!      PARAMETER (N=NPM+2,M=NTHM+2,LNM=5)
      integer,parameter::LNM=5
      real(8),DIMENSION(NTHMAX+3,-1:LNM):: PLM, PLG, D1PLM, D1PLG, D2PLG
      real(8),DIMENSION(0:LNM):: PLTEMP

      real(8),DIMENSION(NPMAX+3,-1:LNM):: FPL
      real(8),DIMENSION(NP2MAX+3,-1:LNM):: FPL2

      real(8),DIMENSION(NTHMAX+3):: TX,TY,DF
      real(8),DIMENSION(4,NTHMAX+3):: UTY
      real(8),dimension(NTHMAX+3)::UTY0
      real(8),DIMENSION(NPMAX+3+NP2MAX):: TX1,TY1,DF1,UTY10
      real(8),DIMENSION(4,NPMAX+3+NP2MAX):: UTY1

      real(8),DIMENSION(-2:LLMAX+2, -1:2):: FKLF_J,FKLF_Y
      real(8),DIMENSION(-2:LLMAX+2, 0:2):: RJ_1, RY_1
      real(8),DIMENSION(NPMAX+4, 0:LLMAX, 0:2, -1:2):: RJABM,RJABG 
      real(8),DIMENSION(NPMAX+4, 0:LLMAX, 0:2, -1:2):: RYABM,RYABG
      real(8),DIMENSION(NP2MAX+4, 0:LLMAX, 0:2, -1:2):: RJABM2,RJABG2 
      real(8),DIMENSION(NP2MAX+4, 0:LLMAX, 0:2, -1:2):: RYABM2,RYABG2

      real(8),DIMENSION(NPMAX+1, 0:LLMAX):: DPSI02M,DPSI022M
      real(8),DIMENSION(NPMAX+1, 0:LLMAX):: PSI0M,PSI02M,PSI022M
      real(8),DIMENSION(NPMAX+1, 0:LLMAX):: PSI1M,PSI11M,DPSI11M
      real(8),DIMENSION(NP2MAX+1, 0:LLMAX):: DPSI02M2,DPSI022M2
      real(8),DIMENSION(NP2MAX+1, 0:LLMAX):: PSI0M2,PSI02M2,PSI022M2
      real(8),DIMENSION(NP2MAX+1, 0:LLMAX):: PSI1M2,PSI11M2,DPSI11M2

      real(8),DIMENSION(NPMAX+2, 0:LLMAX):: DPSI02G,DPSI022G
      real(8),DIMENSION(NPMAX+2, 0:LLMAX):: PSI0G,PSI02G,PSI022G
      real(8),DIMENSION(NPMAX+2, 0:LLMAX):: DPSI1G, DPSI11G
      real(8),DIMENSION(NP2MAX+2, 0:LLMAX):: DPSI02G2,DPSI022G2
      real(8),DIMENSION(NP2MAX+2, 0:LLMAX):: PSI0G2,PSI02G2,PSI022G2
      real(8),DIMENSION(NP2MAX+2, 0:LLMAX):: DPSI1G2, DPSI11G2

      real(8),DIMENSION(-2:LLMAX+2, 0:2):: DERJ, DERY

      integer:: NP, NTH, NSA, NSB, L, NR, LLMIN, NI, NA, NNP, NPG, NSBA
      integer:: IER, NS
      real(8):: RGAMH, TMC2FD0, TMC2FP0, SUM1, SUM2, SUM3, SUM4, SUM5
      real(8):: PSUM, PCRIT, RGAMA, RGAMB, RUFP, FACT, FACT2
      real(8):: SUMA, SUMB, SUMC, SUMD, SUME, SUMF, SUMG, SUMH
      real(8):: vtatb, pabbar, ptatb, PMAX2

      real(8),dimension(NTHMAX,NSBMAX):: delfns
      real(8),dimension(NTHMAX+1,NP2MAX+1,NSBMAX,NSBMAX):: DCPP22, FCPP22, DCTT22, FCTH22
      real(8):: SUMI,SUMJ,SUMK,SUML
      integer:: NBRANCH

      DCPP22=0.D0
      FCPP22=0.D0
      DCTT22=0.D0
      FCTH22=0.D0
!
!----- DEFINITION OF LOCAL QUANTITIES -------------
!
      RGAMH=RNUD(NR,NSB,NSA)*SQRT(2.D0)*VTFD(NR,NSB)*AMFP(NSA) &
           /(RNFP0(NSA)*PTFP0(NSA)*1.D20)
      TMC2FD0=(PTFD0(NSB)/(AMFD(NSB)*VC))**2
      TMC2FP0=(PTFP0(NSA)/(AMFP(NSA)*VC))**2
      NSBA=NSB_NSA(NSA)
!
!   --- calculation of Legendre Polynomials and its derivatives---
!
      LLMIN=0

      DO NTH=1,NTHMAX
         CALL DPLEG(COSM(NTH),LLMAX,PLTEMP,IER)
         DO L=0,LLMAX
            PLM(NTH,L)=PLTEMP(L)
         ENDDO
         PLM(NTH,-1)=0.D0
      END DO

      DO NTH=1,NTHMAX+1
         CALL DPLEG(COSG(NTH),LLMAX,PLTEMP,IER)
         DO L=0,LLMAX
            PLG(NTH,L)=PLTEMP(L)
         ENDDO
         PLG(NTH,-1)=0.D0
      END DO

      DO L=LLMIN,LLMAX
         DO NTH=1,NTHMAX
            D1PLM(NTH,L)=L/SINM(NTH)*(COSM(NTH)*PLM(NTH,L)-PLM(NTH,L-1))
         END DO
      END DO

      DO L=LLMIN,LLMAX
         NTH=1
         D1PLG(NTH,L)=0.D0
         D2PLG(NTH,L)=-0.5D0*L*(L+1)
      END DO
      DO L=LLMIN,LLMAX
         NTH=NTHMAX+1
         D1PLG(NTH,L)=0.D0
         D2PLG(NTH,L)=-0.5D0*L*(L+1)*(-1)**L
      END DO

      DO L=LLMIN,LLMAX
         DO NTH=2,NTHMAX
            D1PLG(NTH,L)=L/SING(NTH)*(COSG(NTH)*PLG(NTH,L)-PLG(NTH,L-1))
            D2PLG(NTH,L)=-(L/(SING(NTH)**2)+L**2)*PLG(NTH,L) &
                 +L*COSG(NTH)/(SING(NTH)**2)*PLG(NTH,L-1)
         END DO
      END DO

      IF(MOD(IDBGFP,2).EQ.1) THEN
!
!     +++ plot of Legendre polynomials and their derivatives +++
!
         CALL PAGES
         CALL GRD1D(1,thm,plm,NTHMAX+3,NTHMAX,LLMAX+2,'@PLM:@',0)
         CALL GRD1D(2,thm,d1plm,NTHMAX+3,NTHMAX,LLMAX+2,'@D1PLM:@',0)
         CALL PAGEE

         CALL PAGES
         CALL GRD1D(1,thg,plg,NTHMAX+3,NTHMAX+1,LLMAX+2,'@PLG:@',0)
         CALL GRD1D(2,thg,d1plg,NTHMAX+3,NTHMAX+1,LLMAX+2,'@D1PLG:@',0)
         CALL GRD1D(3,thg,d2plg,NTHMAX+3,NTHMAX+1,LLMAX+2,'@D2PLG:@',0)
         CALL PAGEE
      ENDIF

!
!     --- PG(1) < x < PG(2) 
!
      DO NS=1,NSBMAX
         DO NTH=1,NTHMAX
            delfns(NTH,NS) = &
                 (FNS(NTH,2,NR,NS)-FNS(NTH,1,NR,NS))/DELP(NS)
            DO NP=1,NP2MAX
               FNS_L(NTH,NP,NR,NS) = &
                    FNS(NTH,1,NR,NS)-delfns(NTH,NS)*(PM(1,NS)-PM2(NP,NS))
            END DO
         END DO
      END DO
      DO L=LLMIN,LLMAX
         DO NP=1,NP2MAX
            TX(1)=0.D0
            TY(1)=0.D0
            DO NTH=1,NTHMAX
               TX(NTH+1)=THM(NTH)
               TY(NTH+1)=FNS_L(NTH,NP,NR,NSB)*PLM(NTH,L)*SINM(NTH)
            END DO
            TX(NTHMAX+2)=PI
            TY(NTHMAX+2)=0.D0
            DF(1)       = FNS_L(1,NP,NR,NSB)*PLM(1,L)*COSM(1)
            DF(NTHMAX+2)= FNS_L(NTHMAX,NP,NR,NSB)*PLM(NTHMAX,L)*COSM(NTHMAX)
            CALL SPL1D(TX,TY,DF,UTY,NTHMAX+2,3,IER)
            CALL SPL1DI0(TX,UTY,UTY0,NTHMAX+2,IER)
            CALL SPL1DI(PI,SUM1,TX,UTY,UTY0,NTHMAX+2,IER)
            FPL2(NP,L)=0.5D0*(2*L+1.D0)*SUM1
         END DO
      END DO

!
!     ----- Legendre expansion of distribution funstion FNS -----
!
!      NS=NS_NSB(NSB)
      DO L=LLMIN,LLMAX
         DO NP=1,NPMAX
            TX(1)=0.D0
            TY(1)=0.D0
            DO NTH=1,NTHMAX
               TX(NTH+1)=THM(NTH)
               TY(NTH+1)=FNS(NTH,NP,NR,NSB)*PLM(NTH,L)*SINM(NTH)
            END DO
            TX(NTHMAX+2)=PI
            TY(NTHMAX+2)=0.D0
            DF(1)       = FNS(1,NP,NR,NSB)*PLM(1,L)*COSM(1)
            DF(NTHMAX+2)= FNS(NTHMAX,NP,NR,NSB)*PLM(NTHMAX,L)*COSM(NTHMAX)
            CALL SPL1D(TX,TY,DF,UTY,NTHMAX+2,3,IER)
            CALL SPL1DI0(TX,UTY,UTY0,NTHMAX+2,IER)
            CALL SPL1DI(PI,SUM1,TX,UTY,UTY0,NTHMAX+2,IER)
            FPL(NP,L)=0.5D0*(2*L+1.D0)*SUM1
         END DO
      END DO
!
!---- INTEGRAL ABBREVIATIONS
!
      vtatb=(AMFD(NSB)*PTFP0(NSA))/(AMFP(NSA)*PTFD0(NSB))
      pabbar=(PTFP0(NSA)*AMFD(NSB))/(PTFD0(NSB)*AMFP(NSA))
!
!---- END OF INTEGRALS
!

!---- INTEGRATION OF RJAB and RYAB
      IF(NSA.eq.1)THEN
         NBRANCH=1
         CALL INTEGRATION_RJAB_RYAB_F(NSB,NSA,NR,FPL,FPL2,RJABG,RJABM,RYABG,RYABM,RJABG2,RJABM2,RYABG2,RYABM2)
      ELSE
         NBRANCH=0
         CALL INTEGRATION_RJAB_RYAB(NSB,NSA,NR,FPL,RJABG,RJABM,RYABG,RYABM)
      END IF
!---- END OF INTEGRATION

!
!---- PSI AND ITS DERIVATIONS
! --- FOR MID GRID
!
      DO L = 0,LLMAX
         DO NP = 1, NPMAX
            RGAMA=SQRT(1.D0+PM(NP,NSBA)**2*TMC2FP0)
            RUFP = (PTFP0(NSA)*PM(NP,NSBA))/AMFP(NSA)

            CALL FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)
            CALL DERIV_JY(RUFP,RJ_1,RY_1,DERJ,DERY)

            DPSI02M(NP,L) = 0.5D0*(                               &
                 DERY(L,0)*RJABM(NP,L,1,1)                        &
                 -(RY_1(L-1,1)+RUFP*DERY(L-1,1) )*RJABM(NP,L,0,2) &
                 +(RJ_1(L+1,1)+RUFP*DERJ(L+1,1) )*RYABM(NP,L,0,0) &
                 -DERJ(L,2)*RYABM(NP,L,1,1) )

            DPSI022M(NP,L) = VC/8.D0*(                            &
                 DERY(L,0)*RJABM(NP,L,2,0)                        &
                 -2.D0*(RY_1(L-1,1)+RUFP*DERY(L-1,1) )            &
                 *(RJABM(NP,L,1,1)+RJABM(NP,L,2,0)/VC)            &
                 +(2.D0*RUFP*RY_1(L-2,0)+RUFP**2*DERY(L-2,0) )    &
                 *RJABM(NP,L,0,2)                                 &
                 +(2.D0*RUFP*RJ_1(L+2,0)+RUFP**2*DERJ(L+2,0) )    &
                 *RYABM(NP,L,0,0)                                 &
                 -2.D0*(RJ_1(L+1,1)+2.D0*RUFP/VC*RJ_1(L+2,0)      &
                 +RUFP*( DERJ(L+1,1)+RUFP/VC*DERJ(L+2,0) ) )      &
                 *RYABM(NP,L,1,1)                                 &
                 +DERJ(L,2)*RYABM(NP,L,2,0) )


            PSI02M(NP,L) = 0.5D0*(                       &
                   RY_1(L,0)*RJABM(NP,L,1,1)             &
                 - RUFP*RY_1(L-1,1)*RJABM(NP,L,0,2)      &
                 + RUFP*RJ_1(L+1,1)*RYABM(NP,L,0,0)      &
                 - RJ_1(L,2)*RYABM(NP,L,1,1)  )


            PSI022M(NP,L) = VC/8.D0*(                                 &
                 RY_1(L,0)*RJABM(NP,L,2,0)                            &
                 -2.D0*RUFP*RY_1(L-1,1)                               &
                 *(RJABM(NP,L,1,1)+RJABM(NP,L,2,0)/VC)                &
                 +RUFP**2*RY_1(L-2,0)*RJABM(NP,L,0,2)                 &
                 +RUFP**2*RJ_1(L+2,0)*RYABM(NP,L,0,0)                 &
                 -2.D0*RUFP                                           &
                 *(RJ_1(L+1,1)+RUFP/VC*RJ_1(L+2,0) )*RYABM(NP,L,1,1)  &
                 +RJ_1(L,2)*RYABM(NP,L,2,0) )

            PSI11M(NP,L) = 0.5D0 * (                &
                 RY_1(L,1)*RJABM(NP,L,1,0)          &
                 -RUFP*RY_1(L-1,0)*RJABM(NP,L,0,1)  &
                 +RUFP*RJ_1(L+1,0)*RYABM(NP,L,0,1)  &
                 -RJ_1(L,1)*RYABM(NP,L,1,0)         &
                 )

            PSI1M(NP,L) = ( RY_1(L,1)*RJABM(NP,L,0,1) &
                 +RJ_1(L,1)*RYABM(NP,L,0,1) )/VC

         END DO
         IF(NBRANCH.eq.1)THEN
            DO NP = 1, NP2MAX
               RGAMA=SQRT(1.D0+PM2(NP,NSBA)**2*TMC2FP0)
               RUFP = (PTFP0(NSA)*PM2(NP,NSBA))/AMFP(NSA)
               
               CALL FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)
               CALL DERIV_JY(RUFP,RJ_1,RY_1,DERJ,DERY)
               
               DPSI02M2(NP,L) = 0.5D0*(                               &
                    DERY(L,0)*RJABM2(NP,L,1,1)                        &
                    -(RY_1(L-1,1)+RUFP*DERY(L-1,1) )*RJABM2(NP,L,0,2) &
                    +(RJ_1(L+1,1)+RUFP*DERJ(L+1,1) )*RYABM2(NP,L,0,0) &
                    -DERJ(L,2)*RYABM2(NP,L,1,1) )
               
               DPSI022M2(NP,L) = VC/8.D0*(                            &
                    DERY(L,0)*RJABM2(NP,L,2,0)                        &
                    -2.D0*(RY_1(L-1,1)+RUFP*DERY(L-1,1) )            &
                    *(RJABM(NP,L,1,1)+RJABM2(NP,L,2,0)/VC)            &
                    +(2.D0*RUFP*RY_1(L-2,0)+RUFP**2*DERY(L-2,0) )    &
                    *RJABM2(NP,L,0,2)                                 &
                    +(2.D0*RUFP*RJ_1(L+2,0)+RUFP**2*DERJ(L+2,0) )    &
                    *RYABM2(NP,L,0,0)                                 &
                    -2.D0*(RJ_1(L+1,1)+2.D0*RUFP/VC*RJ_1(L+2,0)      &
                    +RUFP*( DERJ(L+1,1)+RUFP/VC*DERJ(L+2,0) ) )      &
                    *RYABM2(NP,L,1,1)                                 &
                    +DERJ(L,2)*RYABM2(NP,L,2,0) )
               
               
               PSI02M2(NP,L) = 0.5D0*(                       &
                    RY_1(L,0)*RJABM2(NP,L,1,1)             &
                    - RUFP*RY_1(L-1,1)*RJABM2(NP,L,0,2)      &
                    + RUFP*RJ_1(L+1,1)*RYABM2(NP,L,0,0)      &
                    - RJ_1(L,2)*RYABM2(NP,L,1,1)  )
               
               
               PSI022M2(NP,L) = VC/8.D0*(                                 &
                    RY_1(L,0)*RJABM2(NP,L,2,0)                            &
                    -2.D0*RUFP*RY_1(L-1,1)                               &
                    *(RJABM2(NP,L,1,1)+RJABM2(NP,L,2,0)/VC)                &
                    +RUFP**2*RY_1(L-2,0)*RJABM2(NP,L,0,2)                 &
                    +RUFP**2*RJ_1(L+2,0)*RYABM2(NP,L,0,0)                 &
                    -2.D0*RUFP                                           &
                    *(RJ_1(L+1,1)+RUFP/VC*RJ_1(L+2,0) )*RYABM2(NP,L,1,1)  &
                    +RJ_1(L,2)*RYABM2(NP,L,2,0) )
               
               PSI11M2(NP,L) = 0.5D0 * (                &
                    RY_1(L,1)*RJABM2(NP,L,1,0)          &
                    -RUFP*RY_1(L-1,0)*RJABM2(NP,L,0,1)  &
                    +RUFP*RJ_1(L+1,0)*RYABM2(NP,L,0,1)  &
                    -RJ_1(L,1)*RYABM2(NP,L,1,0)         &
                    )
               
               PSI1M2(NP,L) = ( RY_1(L,1)*RJABM2(NP,L,0,1) &
                    +RJ_1(L,1)*RYABM2(NP,L,0,1) )/VC
               
            END DO
         END IF

      END DO
!
!----------- END OF MID 
!
!
!----------- ON GRID
!
      DO L=0,LLMAX
         DO NP = 2, NPMAX+1
            RGAMA=SQRT(1.D0+PG(NP,NSBA)**2*TMC2FP0)
            RUFP = (PTFP0(NSA)*PG(NP,NSBA))/AMFP(NSA)
            CALL FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)
            CALL DERIV_JY(RUFP,RJ_1,RY_1,DERJ,DERY)

            DPSI02G(NP,L) = 0.5D0*(                               &
                 DERY(L,0)*RJABG(NP,L,1,1)                        &
                 -(RY_1(L-1,1)+RUFP*DERY(L-1,1) )*RJABG(NP,L,0,2) &
                 +(RJ_1(L+1,1)+RUFP*DERJ(L+1,1) )*RYABG(NP,L,0,0) &
                 -DERJ(L,2)*RYABG(NP,L,1,1) )

            DPSI022G(NP,L) = VC/8.D0*(                            &
                 DERY(L,0)*RJABG(NP,L,2,0)                        &
                 -2.D0*(RY_1(L-1,1)+RUFP*DERY(L-1,1) )            &
                 *(RJABG(NP,L,1,1)+RJABG(NP,L,2,0)/VC)            &
                 +(2.D0*RUFP*RY_1(L-2,0)+RUFP**2*DERY(L-2,0) )    &
                 *RJABG(NP,L,0,2)                                 &
                 +(2.D0*RUFP*RJ_1(L+2,0)+RUFP**2*DERJ(L+2,0) )    &
                 *RYABG(NP,L,0,0)                                 &
                 -2.D0*(RJ_1(L+1,1)+2.D0*RUFP/VC*RJ_1(L+2,0)      &
                 +RUFP*( DERJ(L+1,1)+RUFP/VC*DERJ(L+2,0) ) )      &
                 *RYABG(NP,L,1,1)                                 &
                 +DERJ(L,2)*RYABG(NP,L,2,0) )

            PSI0G(NP,L) = ( RY_1(L,0)*RJABG(NP,L,0,0)  &
                 + RJ_1(L,0)*RYABG(NP,L,0,0) )/VC

            PSI02G(NP,L) = 0.5D0*(                     &
                   RY_1(L,0)*RJABG(NP,L,1,1)           &
                 - RUFP*RY_1(L-1,1)*RJABG(NP,L,0,2)    &
                 + RUFP*RJ_1(L+1,1)*RYABG(NP,L,0,0)    &
                 - RJ_1(L,2)*RYABG(NP,L,1,1)  )

            PSI022G(NP,L) = VC/8.D0*(                                &
                 RY_1(L,0)*RJABG(NP,L,2,0)                           &
                 -2.D0*RUFP*RY_1(L-1,1)                              &
                 *(RJABG(NP,L,1,1)+RJABG(NP,L,2,0)/VC)               &
                 +RUFP**2*RY_1(L-2,0)*RJABG(NP,L,0,2)                &
                 +RUFP**2*RJ_1(L+2,0)*RYABG(NP,L,0,0)                &
                 -2.D0*RUFP                                          &
                 *(RJ_1(L+1,1)+RUFP/VC*RJ_1(L+2,0) )*RYABG(NP,L,1,1) &
                 +RJ_1(L,2)*RYABG(NP,L,2,0) )

            DPSI1G(NP,L)=(DERY(L,1)*RJABG(NP,L,0,1)  &
                 + DERJ(L,1)*RYABG(NP,L,0,1) )/VC

            DPSI11G(NP,L) = 0.5D0*(                              &
                  DERY(L,1)*RJABG(NP,L,1,0)                      &
                 -(RY_1(L-1,0)+RUFP*DERY(L-1,0))*RJABG(NP,L,0,1) &
                 +(RJ_1(L+1,0)+RUFP*DERJ(L+1,0))*RYABG(NP,L,0,1) &
                 -DERJ(L,1)*RYABG(NP,L,1,0) )

         END DO

         IF(NBRANCH.eq.1)THEN
            DO NP = 2, NP2MAX+1
               RGAMA=SQRT(1.D0+PG2(NP,NSBA)**2*TMC2FP0)
               RUFP = (PTFP0(NSA)*PG2(NP,NSBA))/AMFP(NSA)
               CALL FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)
               CALL DERIV_JY(RUFP,RJ_1,RY_1,DERJ,DERY)
               
               DPSI02G2(NP,L) = 0.5D0*(                               &
                    DERY(L,0)*RJABG2(NP,L,1,1)                        &
                    -(RY_1(L-1,1)+RUFP*DERY(L-1,1) )*RJABG2(NP,L,0,2) &
                    +(RJ_1(L+1,1)+RUFP*DERJ(L+1,1) )*RYABG2(NP,L,0,0) &
                    -DERJ(L,2)*RYABG2(NP,L,1,1) )
               
               DPSI022G2(NP,L) = VC/8.D0*(                            &
                    DERY(L,0)*RJABG2(NP,L,2,0)                        &
                    -2.D0*(RY_1(L-1,1)+RUFP*DERY(L-1,1) )            &
                    *(RJABG2(NP,L,1,1)+RJABG2(NP,L,2,0)/VC)            &
                    +(2.D0*RUFP*RY_1(L-2,0)+RUFP**2*DERY(L-2,0) )    &
                    *RJABG2(NP,L,0,2)                                 &
                    +(2.D0*RUFP*RJ_1(L+2,0)+RUFP**2*DERJ(L+2,0) )    &
                    *RYABG2(NP,L,0,0)                                 &
                    -2.D0*(RJ_1(L+1,1)+2.D0*RUFP/VC*RJ_1(L+2,0)      &
                    +RUFP*( DERJ(L+1,1)+RUFP/VC*DERJ(L+2,0) ) )      &
                    *RYABG2(NP,L,1,1)                                 &
                    +DERJ(L,2)*RYABG2(NP,L,2,0) )
               
               PSI0G2(NP,L) = ( RY_1(L,0)*RJABG2(NP,L,0,0)  &
                    + RJ_1(L,0)*RYABG2(NP,L,0,0) )/VC
               
               PSI02G2(NP,L) = 0.5D0*(                     &
                    RY_1(L,0)*RJABG2(NP,L,1,1)           &
                    - RUFP*RY_1(L-1,1)*RJABG2(NP,L,0,2)    &
                    + RUFP*RJ_1(L+1,1)*RYABG2(NP,L,0,0)    &
                    - RJ_1(L,2)*RYABG2(NP,L,1,1)  )
               
               PSI022G2(NP,L) = VC/8.D0*(                                &
                    RY_1(L,0)*RJABG2(NP,L,2,0)                           &
                    -2.D0*RUFP*RY_1(L-1,1)                              &
                    *(RJABG2(NP,L,1,1)+RJABG2(NP,L,2,0)/VC)               &
                    +RUFP**2*RY_1(L-2,0)*RJABG2(NP,L,0,2)                &
                    +RUFP**2*RJ_1(L+2,0)*RYABG2(NP,L,0,0)                &
                    -2.D0*RUFP                                          &
                    *(RJ_1(L+1,1)+RUFP/VC*RJ_1(L+2,0) )*RYABG2(NP,L,1,1) &
                    +RJ_1(L,2)*RYABG2(NP,L,2,0) )
               
               DPSI1G2(NP,L)=(DERY(L,1)*RJABG2(NP,L,0,1)  &
                    + DERJ(L,1)*RYABG2(NP,L,0,1) )/VC
               
               DPSI11G2(NP,L) = 0.5D0*(                              &
                    DERY(L,1)*RJABG2(NP,L,1,0)                      &
                    -(RY_1(L-1,0)+RUFP*DERY(L-1,0))*RJABG2(NP,L,0,1) &
                    +(RJ_1(L+1,0)+RUFP*DERJ(L+1,0))*RYABG2(NP,L,0,1) &
                    -DERJ(L,1)*RYABG2(NP,L,1,0) )
               
            END DO
         END IF
      END DO

!
!----------END OF ON GIRD
!---- END OF PSI AND ITS DERIVATIVES

!
!--- LOCAL DIFFUSION COEFFICIENTS
!
      FACT=4.D0*PI*RGAMH*1.D20 &
           * (PTFP0(NSA) / AMFP(NSA))*RNFD0(NSB) 
      FACT2=4.D0*PI*RGAMH*1.D20 &
           * (PTFP0(NSA) / AMFP(NSA))**2*RNFD0(NSB)
!-----DCPP & FCPP-----------------
      DO NP=2,NPMAX+1
         RGAMA=SQRT(1.D0+PG(NP,NSBA)**2*TMC2FP0)
         RUFP = (PTFP0(NSA)*PG(NP,NSBA))/AMFP(NSA)
         DO NTH=1,NTHMAX
            DO L=LLMIN,LLMAX
               SUMA = DPSI02G(NP,L)*PLM(NTH,L)
               SUMB = DPSI022G(NP,L)*PLM(NTH,L)
               SUMC = PSI0G(NP,L) * PLM(NTH,L)
               SUMD = PSI02G(NP,L) * PLM(NTH,L)
               SUME = PSI022G(NP,L) * PLM(NTH,L)
               SUMF = DPSI1G(NP,L) * PLM(NTH,L)
               SUMG = DPSI11G(NP,L) * PLM(NTH,L)

               DCPP2(NTH,NP,NR,NSB,NSA)=DCPP2(NTH,NP,NR,NSB,NSA) &
                 + FACT * RGAMA / RUFP *(                        &
                 2.D0*RGAMA**2* SUMA                             &
                 -8.D0*(RGAMA/VC)**2* SUMB                       &
                 -RUFP* SUMC - L*(L+1)/RUFP* SUMD                &
                 +(8.D0*(RUFP/VC)**2+4.D0*L*(L+1))/(RUFP*VC**2)  &
                 *SUME    )

               FCPP2(NTH,NP,NR,NSB,NSA) = FCPP2(NTH,NP,NR,NSB,NSA) &
                    +FACT2 * AMFP(NSA)/AMFD(NSB)*RGAMA             &
                    *( -SUMF + 2.D0/VC**2*SUMG )
            END DO
         END DO
      END DO


      DO NTH=1,NTHMAX
         NP=2
         RGAMA=SQRT(1.D0+PG(NP,NSBA)**2*TMC2FP0)
         RUFP = (PTFP0(NSA)*PG(NP,NSBA))/AMFP(NSA)
         DCPP2(NTH,1,NR,NSB,NSA)                                          &
              =RGAMH*RNFD(NR,NSB)*1.D20*(2.D0/(3.D0*SQRT(PI)))            &
              *(PTFP0(NSA)/(SQRT(2.D0)*PTFD(NR,NSB)))*AMFD(NSB)/AMFP(NSA)
         FCPP2(NTH,1,NR,NSB,NSA)=0.D0
      END DO

      IF(NBRANCH.eq.1)THEN
         DO NP=2,NP2MAX+1
            RGAMA=SQRT(1.D0+PG2(NP,NSBA)**2*TMC2FP0)
            RUFP = (PTFP0(NSA)*PG2(NP,NSBA))/AMFP(NSA)
            DO NTH=1,NTHMAX
               DO L=LLMIN,LLMAX
                  SUMA = DPSI02G2(NP,L)*PLM(NTH,L)
                  SUMB = DPSI022G2(NP,L)*PLM(NTH,L)
                  SUMC = PSI0G2(NP,L) * PLM(NTH,L)
                  SUMD = PSI02G2(NP,L) * PLM(NTH,L)
                  SUME = PSI022G2(NP,L) * PLM(NTH,L)
                  SUMF = DPSI1G2(NP,L) * PLM(NTH,L)
                  SUMG = DPSI11G2(NP,L) * PLM(NTH,L)
                  
                  DCPP22(NTH,NP,NSB,NSA)=DCPP22(NTH,NP,NSB,NSA)  &
                       + FACT * RGAMA / RUFP *(                        &
                       2.D0*RGAMA**2* SUMA                             &
                       -8.D0*(RGAMA/VC)**2* SUMB                       &
                       -RUFP* SUMC - L*(L+1)/RUFP* SUMD                &
                       +(8.D0*(RUFP/VC)**2+4.D0*L*(L+1))/(RUFP*VC**2)  &
                       *SUME    )
                  
                  FCPP22(NTH,NP,NSB,NSA) = FCPP22(NTH,NP,NSB,NSA) &
                       + FACT2 * AMFP(NSA)/AMFD(NSB)*RGAMA             &
                       *( -SUMF + 2.D0/VC**2*SUMG )
               END DO
            END DO
         END DO
      END IF
!  --- weighted mean average -----  
      IF(NBRANCH.eq.1)THEN
      DO NTH=1,NTHMAX
         SUMI=0.D0
         SUMJ=0.D0
         SUMK=0.D0
         DO NP=1,NP2MAX
            SUMI=SUMI+DCPP22(NTH,NP,NSB,NSA)*PG2(NP,NSA)**2
            SUMJ=SUMJ+PG2(NP,NSA)**2
            SUMK=SUMK+FCPP22(NTH,NP,NSB,NSA)*PG2(NP,NSA)**2
         END DO
!         DCPP2(NTH,2,NR,NSB,NSA)=SUMI/SUMJ
!         FCPP2(NTH,2,NR,NSB,NSA)=SUMK/SUMJ
      END DO
      END IF
!  --- weighted mean average -----  

!      IF(NSA.eq.1.and.NSB.eq.1.and.nr.eq.1)THEN
!         NTH=2
!         open(8,file='test_DC_r1.dat')
!      DO NP=1, NPMAX
 !        write(8,*) PG(NP,NSA), DCPP2(NTH,NP,NR,NSB,NSa),FCPP2(NTH,NP,NR,NSB,NSA)
 !     END DO
 !     write(8,*)" "
 !     write(8,*)" "
 !     DO NP=2, NP2MAX
 !        write(8,*) PG2(NP,NSA), DCPP22(NTH,NP,NSB,NSA),FCPP22(NTH,NP,NSB,NSA)
 !!     END DO
  !    close(8)
  !    END IF

!-----DCTT & FCTH--------------------

      DO NP=1,NPMAX
         RGAMA=SQRT(1.D0+PM(NP,NSBA)**2*TMC2FP0)
         RUFP = (PTFP0(NSA)*PM(NP,NSBA))/AMFP(NSA)
         DO NTH=1,NTHMAX+1
            SUMA = 0.D0
            SUMB = 0.D0
            SUMC = 0.D0
            SUMD = 0.D0
            SUME = 0.D0
            SUMF = 0.D0
            SUMG = 0.D0
            SUMH = 0.D0
            DO L=LLMIN,LLMAX
               SUMA = SUMA + DPSI02M(NP,L) * PLG(NTH,L)
               SUMB = SUMB + PSI02M(NP,L) * PLG(NTH,L)
               SUMC = SUMC + PSI02M(NP,L) * D2PLG(NTH,L)
               SUMD = SUMD + DPSI022M(NP,L) * PLG(NTH,L)
               SUME = SUME + PSI022M(NP,L) * PLG(NTH,L)
               SUMF = SUMF + PSI022M(NP,L) * D2PLG(NTH,L)
               SUMG = SUMG + PSI1M(NP,L) * D1PLG(NTH,L)
               SUMH = SUMH + PSI11M(NP,L) * D1PLG(NTH,L)
            END DO
            DCTT2(NTH,NP,NR,NSB,NSA) = DCTT2(NTH,NP,NR,NSB,NSA)   &
                 +FACT/RGAMA/RUFP                                 &
                 *(-RGAMA**2*SUMA - RUFP/VC**2*SUMB + SUMC/RUFP   &
                 +4.D0*RGAMA**2/VC**2*SUMD                        &
                 - (4.D0*RUFP/VC**4*SUME - 4.D0/RUFP/VC**2*SUMF ) &
                 )

            FCTH2(NTH,NP,NR,NSB,NSA) = FCTH2(NTH,NP,NR,NSB,NSA) &
                 + FACT2 * AMFP(NSA)/AMFD(NSB)/RGAMA/RUFP       & 
                 *(- SUMG + 2.D0/VC**2*SUMH )

         END DO
      END DO

      IF(NSA.eq.1.and.NSB.ne.NSA)THEN
         DO NP=1,NP2MAX
            RGAMA=SQRT(1.D0+PM2(NP,NSBA)**2*TMC2FP0)
            RUFP = (PTFP0(NSA)*PM2(NP,NSBA))/AMFP(NSA)
            DO NTH=1,NTHMAX+1
               SUMA = 0.D0
               SUMB = 0.D0
               SUMC = 0.D0
               SUMD = 0.D0
               SUME = 0.D0
               SUMF = 0.D0
               SUMG = 0.D0
               SUMH = 0.D0
               DO L=LLMIN,LLMAX
                  SUMA = SUMA + DPSI02M2(NP,L) * PLG(NTH,L)
                  SUMB = SUMB + PSI02M2(NP,L) * PLG(NTH,L)
                  SUMC = SUMC + PSI02M2(NP,L) * D2PLG(NTH,L)
                  SUMD = SUMD + DPSI022M2(NP,L) * PLG(NTH,L)
                  SUME = SUME + PSI022M2(NP,L) * PLG(NTH,L)
                  SUMF = SUMF + PSI022M2(NP,L) * D2PLG(NTH,L)
                  SUMG = SUMG + PSI1M2(NP,L) * D1PLG(NTH,L)
                  SUMH = SUMH + PSI11M2(NP,L) * D1PLG(NTH,L)
               END DO
               DCTT22(NTH,NP,NSB,NSA) = DCTT22(NTH,NP,NSB,NSA)   &
                    +FACT/RGAMA/RUFP                                 &
                    *(-RGAMA**2*SUMA - RUFP/VC**2*SUMB + SUMC/RUFP   &
                    +4.D0*RGAMA**2/VC**2*SUMD                        &
                    - (4.D0*RUFP/VC**4*SUME - 4.D0/RUFP/VC**2*SUMF ) &
                    )
               FCTH22(NTH,NP,NSB,NSA) = FCTH22(NTH,NP,NSB,NSA) &
                    + FACT2 * AMFP(NSA)/AMFD(NSB)/RGAMA/RUFP       & 
                 *(- SUMG + 2.D0/VC**2*SUMH )
            END DO
         END DO
      END IF
!  --- weighted mean average -----  
      IF(NSA.eq.1)THEN
      DO NTH=1,NTHMAX
         SUMI=0.D0
         SUMJ=0.D0
         SUMK=0.D0
         SUML=0.D0
         DO NP=1,NP2MAX
            SUMI=SUMI+DCTT22(NTH,NP,NSB,NSA)/PM2(NP,NSA)
            SUMJ=SUMJ+1.D0/PM2(NP,NSA)
            SUMK=SUMK+FCTH22(NTH,NP,NSB,NSA)
            SUML=SUML+1.D0
         END DO
!         DCTT2(NTH,2,NR,NSB,NSA)=SUMI/SUMJ
!         FCTH2(NTH,2,NR,NSB,NSA)=SUMK/SUML
      END DO
      END IF
!  --- weighted mean average -----  
!      IF(NSA.eq.1.and.NSB.eq.2)THEN
!         NTH=2
!         open(8,file='test_DCTT.dat')
!      DO NP=1, NPMAX
!         write(8,*) PM(NP,NSA), DCTT2(NTH,NP,NR,NSB,NSa),FCTH2(NTH,NP,NR,NSB,NSA)
!      END DO
!      write(8,*)" "
!      write(8,*)" "
!      DO NP=2, NP2MAX
!         write(8,*) PM2(NP,NSA), DCTT22(NTH,NP,NR,NSB,NSA),FCTH22(NTH,NP,NR,NSB,NSA)
!      END DO
!      close(8)
!      END IF


!-----DCPT & DCTP
      DO NTH=1,NTHMAX
         DCPT2(NTH,1,NR,NSB,NSA)=0.D0
      END DO

      DO NP=2,NPMAX+1
         RGAMA=SQRT(1.D0+PG(NP,NSBA)**2*TMC2FP0)
         RUFP = (PTFP0(NSA)*PG(NP,NSBA))/AMFP(NSA)
         DO NTH=1,NTHMAX
            SUMA = 0.D0
            SUMB = 0.D0
            SUMC = 0.D0
            SUMD = 0.D0
            DO L=LLMIN,LLMAX
               SUMA = SUMA + DPSI022G(NP,L) * D1PLM(NTH,L)
               SUMB = SUMB + DPSI02G(NP,L) * D1PLM(NTH,L)
               SUMC = SUMC + PSI022G(NP,L) * D1PLM(NTH,L)
               SUMD = SUMD + PSI02G(NP,L) * D1PLM(NTH,L)
            END DO
            DCPT2(NTH,NP,NR,NSB,NSA) = DCPT2(NTH,NP,NR,NSB,NSA)  &
                 +FACT*RGAMA/RUFP                                &
                 *( 4.D0/VC**2*SUMA - SUMB                       &
                 - 4.D0/(RUFP*VC**2)*SUMC + SUMD/RUFP )
         END DO
      END DO

      DO NP=1,NPMAX
         RGAMA=SQRT(1.D0+PM(NP,NSBA)**2*TMC2FP0)
         RUFP = (PTFP0(NSA)*PM(NP,NSBA))/AMFP(NSA)
         DO NTH=1,NTHMAX+1
            SUMA = 0.D0
            SUMB = 0.D0
            SUMC = 0.D0
            SUMD = 0.D0
            DO L=LLMIN,LLMAX
               SUMA = SUMA + DPSI022M(NP,L) * D1PLG(NTH,L)
               SUMB = SUMB + DPSI02M(NP,L) * D1PLG(NTH,L)
               SUMC = SUMC + PSI022M(NP,L) * D1PLG(NTH,L)
               SUMD = SUMD + PSI02M(NP,L) * D1PLG(NTH,L)
            END DO
            DCTP2(NTH,NP,NR,NSB,NSA) = DCTP2(NTH,NP,NR,NSB,NSA) &
                 +FACT*RGAMA/RUFP                               &
                 *( 4.D0/VC**2*SUMA - SUMB                      &
                 - 4.D0/(RUFP*VC**2)*SUMC + SUMD/RUFP )
         END DO
      END DO

      RETURN
      END SUBROUTINE FPCALC_NLR
 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!---- RECURRENCE EQUATION OF FIRST KIND LEGENDRE FUNCTION
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      SUBROUTINE FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)

      IMPLICIT NONE

      real(8),DIMENSION(-2:LLMAX+2, -1:2):: FKLF_J,FKLF_Y
      real(8),DIMENSION(-2:LLMAX+2, 0:2):: RJ_1, RY_1
      integer:: L, NA
      real(8):: RUFP, RGAMA, RZ, RSIGMA, ra1

!     FKLF_J(L,NA) = P^{-L-1/2}_{A-1/2}
!     FKLF_Y(L,NA) = P^{L+1/2}_{A-1/2}
!     RJ_1(L,NA) = j_{L[1]NA}
!     RY_1(L,NA) = y_{L[1]NA}

!
!---- INITIALIZE
!
      Do L = -2, LLMAX+2
         Do NA=-1,2
            FKLF_J(L,NA)=0.D0
            FKLF_Y(L,NA)=0.D0
         END DO
         DO NA=0,2
            RJ_1(L,NA)=0.D0
            RY_1(L,NA)=0.D0
         END DO
      END DO
!
!---- END OF INITIALIZATION
!
      RGAMA= sqrt(1.D0+(RUFP/VC)**2)
      RZ = RUFP/VC
      IF(RZ.le.1.d-1)THEN
         RSIGMA =                 &
              5.D0/384.D0*RZ**9   &
              -5.D0/112.D0*RZ**7  &
              +3.D0/40.D0*RZ**5   &
              -RZ**3/6.D0         &
              +RZ

      ELSE
         RSIGMA = LOG(RZ+SQRT(1.D0+RZ**2))
      END IF

!
!---- FIRST KIND LEGENDRE FUN!TION FOR J
!
      FKLF_J(0,0) = sqrt(2.D0*VC/PI/RUFP)*RSIGMA
      FKLF_J(0,1) = sqrt(2.D0*RUFP/PI/VC)
      FKLF_J(0,2) = sqrt(2.D0*RUFP/PI/VC)*RGAMA
      FKLF_J(0,-1) = FKLF_J(0,1)

!
!---- FIRST KIND LEGENDRE FUNCTION FOR Y
!
      FKLF_Y(0,0) = sqrt(2.D0*VC/PI/RUFP)
      FKLF_Y(0,1) = sqrt(2.D0*VC/PI/RUFP)*RGAMA
      FKLF_Y(0,2) = sqrt(2.D0*RUFP/PI/VC)*(VC/RUFP+2.D0*RUFP/VC)
      FKLF_Y(0,-1) = FKLF_Y(0,1)
!
!---- RECURRENCE EQUATION 
!
      Do L = 0, LLMAX+1
         Do NA = 0, 2
            FKLF_J(L+1,NA) = (RGAMA*FKLF_J(L,NA)-FKLF_J(L,NA-1)) &
                 *VC/RUFP/DBLE(NA+L+1)
            FKLF_Y(L+1,NA) =                                           &
                 ( (NA-L-1)*RGAMA*FKLF_Y(L,NA)-(NA+L)*FKLF_Y(L,NA-1) ) &
                 *VC/RUFP
         END DO

         FKLF_J(L+1,-1)=FKLF_J(L+1,1)
         FKLF_Y(L+1,-1)=FKLF_Y(L+1,1)
      END DO

!
!--- ANALYZED J, Y
!

         RJ_1(0,0) = RSIGMA/RZ
         RJ_1(0,1) = 1.D0
         RJ_1(0,2) = RGAMA
         
         RJ_1(1,0) = (RGAMA*RSIGMA-RZ)/RZ**2
         RJ_1(1,1) = (RZ*RGAMA-RSIGMA)*0.5D0/RZ**2
         RJ_1(1,2) = RZ / 3.D0
         
         IF(RZ.le.2.D-4)THEN
            RJ_1(2,0) = ( (4.D0/15.D0)*RZ**2  &
                 -(15.D0/112.D0+3.D0/80.D0)*RZ**4 )/4.D0
            RJ_1(2,1) =(3.D0/12.D0*RZ**2 - 29.D0/80.D0*RZ**4 )/6.D0
            RJ_1(2,2) = (8.D0/5.D0*RZ**2 - 4.D0/7.D0*RZ**4 )/24.D0
         ELSE
            RJ_1(2,0) = ( (2.D0*RGAMA**2+1.D0)*RSIGMA-3.D0*RGAMA*RZ ) &
                 /4.D0/RZ**3
            RJ_1(2,1) =((RGAMA**2+2.D0)*RZ-3.D0*RGAMA*RSIGMA)/6.D0/RZ**3
            RJ_1(2,2) =  &
                (2.D0*RGAMA*RZ**3-3.D0*RZ*RGAMA+3.D0*RSIGMA)/24.D0/RZ**3
         END IF

         RY_1(0,0) = -1.D0/RZ
         RY_1(0,1) = -RGAMA/RZ
         RY_1(0,2) = -(1.D0+2.D0*RZ**2)/RZ

         RY_1(1,0) = -RGAMA/RZ**2
         RY_1(1,1) = -1.D0/RZ**2
         RY_1(1,2) = -(1.D0-2.D0*RZ**2)*RGAMA/RZ**2

         RY_1(2,0) = -(1.D0+2.D0*RGAMA**2)/RZ**3
         RY_1(2,1) = -3.D0*RGAMA/RZ**3
         RY_1(2,2) = -3.D0/RZ**3

         IF(LLMAX.ge.1)THEN
            IF(RZ.le.1.D-2)THEN
            RJ_1(3,0) =                                   &
                 ( (81.D0/80.D0-75.D0/112.D0)*RZ**3       &
                    -13.D0/320.D0*RZ**5-9.D0/160.D0*RZ**7 &
                    )/36.D0
            RJ_1(3,1) =                                   &
                 ( (11.D0/16.D0-0.9D0+75.D0/112.D0)*RZ**3 &
                 + (1.D0/8.D0+15.D0/28.D0)*RZ**5)/48.D0
            RJ_1(3,2) =                             &
                 ( (29.D0/240.D0-5.D0/112.D0)*RZ**3 &
                 -(11.D0/336.D0+3.D0/320.D0)*RZ**5 )*15.D0/120.D0

            ELSE
            RJ_1(3,0) =                                   &
                 ( (6.D0*RGAMA**2+9.D0)*RGAMA*RSIGMA      &
                 -(11.D0*RGAMA**2+4.D0)*RZ )/36.D0/RZ**4
            RJ_1(3,1) =                                   &
                 ((2.D0*RGAMA**2+13.D0)*RGAMA*RZ          &
                 -3.D0*(4.D0*RGAMA**2+1.D0)*RSIGMA)/48.D0/RZ**4
            RJ_1(3,2) =                                       &
                 (2.D0*RGAMA**2*RZ**3-(7.D0*RGAMA**2+8.D0)*RZ &
                 +15.D0*RGAMA*RSIGMA )/120.D0/RZ**4
            END IF
            RY_1(3,0) = -(3.D0*RGAMA*(3.D0+2.D0*RGAMA**2))/RZ**4
            RY_1(3,1) = -3.D0*(1.D0+4.D0*RGAMA**2)/RZ**4
            RY_1(3,2) = -15.D0*RGAMA/RZ**4

         END IF

         IF(LLMAX.ge.2)THEN
            RSIGMA = LOG(RZ+SQRT(1.D0+RZ**2))
            IF(RZ.le.3.D-2)THEN
               RJ_1(4,0) = (9.D0/5.D0)*RZ**4/576.D0
               RJ_1(4,1) = ((357.D0/64.D0)*RZ**4  &
                    -(999.D0/224.D0+19.D0/16.D0)*RZ**6 )/720.D0
               RJ_1(4,2) = (525.D0/96.D0-267.D0/56.D0)*RZ**4/1440.D0
            ELSE
               ra1 = 105.D0*(RSIGMA-RGAMA*RZ)
               RJ_1(4,0) =                               &
                    (3.D0*(8.D0*RZ**4+4.D1*RZ**2)*RSIGMA &
                    -50.D0*RGAMA*RZ**3+RA1)/576.D0/RZ**5

               RJ_1(4,1) = ((6.D0*rgama**4+83.D0*RGAMA**2+16.D0)*RZ &
                    -(60.D0*RGAMA**2+45.D0)*RGAMA*RSIGMA )/720.D0/RZ**5
               RJ_1(4,2) = ((90.D0*RGAMA**2+15.D0)*RSIGMA +              &
                    (4.D0*RGAMA**2*RZ**2-24.D0*RGAMA**2-81.D0)*RGAMA*RZ) &
                    /1440.D0/RZ**5               
            END IF
            RY_1(4,0) = &
                 -3.D0*(8.D0*RGAMA**4+24.D0*RGAMA**2+3.D0)/RZ**5
            RY_1(4,1) = &
                 -15.D0*RGAMA*(4.D0*RGAMA**2+3.D0)/RZ**5
            RY_1(4,2) = &
                 -15.D0*(6.D0*RGAMA**2+1.D0)/RZ**5
         END IF

      DO NA=0,2
!         Do L=0,LLMAX+2
!             RJ_1(L,NA)=SQRT(PI*VC/2.D0/RUFP)*FKLF_J(L,NA)
!             RY_1(L,NA)=SQRT(PI*VC/2.D0/RUFP)*FKLF_Y(L,NA)*(-1)**(-L-1)
!         END DO
         RJ_1(-1,NA) = - RY_1(0,NA)
         RY_1(-1,NA) = RJ_1(0,NA)
         RJ_1(-2,NA) = RY_1(1,NA)
         RY_1(-2,NA) = - RJ_1(1,NA)
      END DO


 935  FORMAT(4E12.4)
      Return
      END SUBROUTINE FKLF_JY

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!     DERIVATION J Y
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE DERIV_JY(RUFP,RJ_1,RY_1,DERJ,DERY)

      IMPLICIT NONE

      real(8),DIMENSION(-2:LLMAX+2, -1:2):: FKLF_J,FKLF_Y
      real(8),DIMENSION(-2:LLMAX+2, 0:2):: RJ_1, RY_1, DERJ, DERY
      integer:: L, NA
      real(8):: RUFP, RGAMA, RZ, RSIGMA

!
      Do L = -2, LLMAX+2
         DO NA=0,2
            DERY(L,NA)=0.D0
            DERJ(L,NA)=0.D0
         END DO
      END DO
!
!---- END OF INITIALIZATION
!
      RGAMA= sqrt(1.D0+(RUFP/VC)**2)

      DO NA = 0, 2
         DO L= -1, LLMAX+2
           DERJ(L,NA) = RJ_1(L-1,NA)/(VC*RGAMA) - (L+1)/RUFP*RJ_1(L,NA)
         END DO
         DO L= -2, LLMAX+1
           DERY(L,NA) =-RY_1(L+1,NA)/(VC*RGAMA) + L/RUFP*RY_1(L,NA)
         END DO
      END DO

      RETURN
      END SUBROUTINE DERIV_JY

!----------------------------------------------------

      SUBROUTINE INTEGRATION_RJAB_RYAB_F(NSB,NSA,NR,FPL,FPL2,RJABG,RJABM,RYABG,RYABM,RJABG2,RJABM2,RYABG2,RYABM2)

      IMPLICIT NONE

      integer,parameter::LNM=5

      real(8),DIMENSION(NPMAX+3,-1:LNM):: FPL
      real(8),DIMENSION(NP2MAX+3,-1:LNM):: FPL2

      real(8),DIMENSION(NTHMAX+3):: TX,TY,DF
      real(8),DIMENSION(4,NTHMAX+3):: UTY
      real(8),dimension(NTHMAX+3)::UTY0
      real(8),DIMENSION(NPMAX+3+NP2MAX):: TX1,TY1,DF1,UTY10
      real(8),DIMENSION(4,NPMAX+3+NP2MAX):: UTY1

      real(8),DIMENSION(-2:LLMAX+2, -1:2):: FKLF_J,FKLF_Y
      real(8),DIMENSION(-2:LLMAX+2, 0:2):: RJ_1, RY_1
      real(8),DIMENSION(NPMAX+4, 0:LLMAX, 0:2, -1:2):: RJABM,RJABG 
      real(8),DIMENSION(NPMAX+4, 0:LLMAX, 0:2, -1:2):: RYABM,RYABG
      real(8),DIMENSION(NP2MAX+4, 0:LLMAX, 0:2, -1:2):: RJABM2,RJABG2 
      real(8),DIMENSION(NP2MAX+4, 0:LLMAX, 0:2, -1:2):: RYABM2,RYABG2

      integer:: NP, NTH, NSA, NSB, L, NR, LLMIN, NI, NA, NNP, NPG, NSBA
      integer:: IER, NS
      real(8):: RGAMH, TMC2FD0, TMC2FP0, SUM1, SUM2, SUM3, SUM4, SUM5
      real(8):: PSUM, PCRIT, RGAMA, RGAMB, RUFP, FACT, FACT2
      real(8):: vtatb, pabbar, ptatb, PMAX2

!
!----- DEFINITION OF LOCAL QUANTITIES -------------
!
      RGAMH=RNUD(NR,NSB,NSA)*SQRT(2.D0)*VTFD(NR,NSB)*AMFP(NSA) &
           /(RNFP0(NSA)*PTFP0(NSA)*1.D20)
      TMC2FD0=(PTFD0(NSB)/(AMFD(NSB)*VC))**2
      TMC2FP0=(PTFP0(NSA)/(AMFP(NSA)*VC))**2
      NSBA=NSB_NSA(NSA)

      vtatb=(AMFD(NSB)*PTFP0(NSA))/(AMFP(NSA)*PTFD0(NSB))
      pabbar=(PTFP0(NSA)*AMFD(NSB))/(PTFD0(NSB)*AMFP(NSA))

      DO NI = 0, 2
      DO NA = 0, 2

!-----INTEGRATION OF RJAB
      DO L=0,LLMAX
!------- CALCULATION OF SPLINE COEFFICIENTS
         TX1(1)=0.D0
         TY1(1)=0.D0
!        0<x<PM2(10)
         DO NNP=1,NP2MAX
            RGAMB=SQRT(1.D0+PM2(NNP,NSB)**2*TMC2FD0)
            RUFP = (PTFD0(NSB)*PM2(NNP,NSB))/AMFD(NSB)
            CALL FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)
            TX1(NNP+1)=PM2(NNP,NSB)
            TY1(NNP+1)=FPL2(NNP,L)*(PM2(NNP,NSB)**(2+NI))/RGAMB &
                 *RJ_1(L+NI,NA)
         END DO
!        PM(2)<x<PM(NPMAX)
         DO NNP=2,NPMAX
            RGAMB=SQRT(1.D0+PM(NNP,NSB)**2*TMC2FD0)
            RUFP = (PTFD0(NSB)*PM(NNP,NSB))/AMFD(NSB)
            CALL FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)
            TX1(NNP+NP2MAX)=PM(NNP,NSB)
            TY1(NNP+NP2MAX)=FPL(NNP,L)*(PM(NNP,NSB)**(2+NI))/RGAMB &
                 *RJ_1(L+NI,NA)
         END DO
         TX1(NPMAX+NP2MAX+1)=PMAX(NSB)
         TY1(NPMAX+NP2MAX+1)=0.D0
         DF1(1)   = 0.D0
         DF1(NPMAX+NP2MAX+1)   = 0.D0
         PMAX2=PMAX(NSB)
!         IF(NSA.eq.1.and.NSB.eq.2.and.l.eq.0.and.NR.eq.1)THEN
!            DO NP=1,NPMAX+NP2MAX+1
!               WRITE(*,*)TX1(NP),TY1(NP)
!            END DO
!            WRITE(*,*)" "
!            WRITE(*,*)" "
!         END IF
         CALL SPL1D(TX1,TY1,DF1,UTY1,NPMAX+NP2MAX+1,3,IER)
         CALL SPL1DI0(TX1,UTY1,UTY10,NPMAX+NP2MAX+1,IER)
         CALL SPL1DI(PMAX2,PSUM,TX1,UTY1,UTY10,NPMAX+NP2MAX+1,IER)
!------- END OF CALCULATION OF SPLINE COEFFICIENTS
         DO NP=1,NPMAX
            RGAMA=SQRT(1.D0+PM(NP,NSBA)**2*TMC2FP0)
            ptatb=PM(NP,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM2,TX1,UTY1,UTY10,NPMAX+NP2MAX+1,IER)
               RJABM(NP,L,NI,NA)=SUM2*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RJABM(NP,L,NI,NA)=PSUM*(PTFD0(NSB)/AMFD(NSB))**NI
            ENDIF
         END DO
         DO NPG=1,NPMAX+1
            RGAMA=SQRT(1.D0+PG(NPG,NSBA)**2*TMC2FP0)
            ptatb=PG(NPG,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM3,TX1,UTY1,UTY10,NPMAX+NP2MAX+1,IER)
               RJABG(NPG,L,NI,NA)=SUM3*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RJABG(NPG,L,NI,NA)=PSUM*(PTFD0(NSB)/AMFD(NSB))**NI
            ENDIF
         END DO
! ------ PG2 and PM2
         DO NP=1,NP2MAX
            RGAMA=SQRT(1.D0+PM2(NP,NSBA)**2*TMC2FP0)
            ptatb=PM2(NP,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM2,TX1,UTY1,UTY10,NPMAX+NP2MAX+1,IER)
               RJABM2(NP,L,NI,NA)=SUM2*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RJABM2(NP,L,NI,NA)=PSUM*(PTFD0(NSB)/AMFD(NSB))**NI
            ENDIF
         END DO
         DO NPG=1,NP2MAX+1
            RGAMA=SQRT(1.D0+PG2(NPG,NSBA)**2*TMC2FP0)
            ptatb=PG2(NPG,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM3,TX1,UTY1,UTY10,NPMAX+NP2MAX+1,IER)
               RJABG2(NPG,L,NI,NA)=SUM3*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RJABG2(NPG,L,NI,NA)=PSUM*(PTFD0(NSB)/AMFD(NSB))**NI
            ENDIF
         END DO
      END DO
!---- END OF RJAB

!---- INTEGRATION OF RYAB
      DO L=0,LLMAX
         TX1(1)=0.D0
         TY1(1)=0.D0
         DO NNP=1,NP2MAX
            RGAMB=SQRT(1.D0+PM2(NNP,NSB)**2*TMC2FD0)
            RUFP = (PTFD0(NSB)*PM2(NNP,NSB))/AMFD(NSB)
            CALL FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)
            TX1(NNP+1)=PM2(NNP,NSB)
            TY1(NNP+1)=FPL2(NNP,L)*(PM2(NNP,NSB)**(2+NI))/RGAMB &
                 *RY_1(L-NI,NA)
         END DO
         DO NNP=2,NPMAX
            RGAMB=SQRT(1.D0+PM(NNP,NSB)**2*TMC2FD0)
            RUFP = (PTFD0(NSB)*PM(NNP,NSB))/AMFD(NSB)
            CALL FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)
            TX1(NNP+NP2MAX)=PM(NNP,NSB)
            TY1(NNP+NP2MAX)=FPL(NNP,L)*(PM(NNP,NSB)**(2+NI))/RGAMB &
                 *RY_1(L-NI,NA)
         END DO
         TX1(NP2MAX+NPMAX+1)=PMAX(NSB)
         TY1(NP2MAX+NPMAX+1)=0.D0
         IF(NI.ne.0)THEN
            DF1(1)   = 0.D0
         ELSE
            DF(1) = - AMFD(NSB)*VC/PTFD0(NSB)*FPL(1,L)
         END IF
         DF1(NP2MAX+NPMAX+1)   = 0.D0
         PMAX2=PMAX(NSB)
         CALL SPL1D(TX1,TY1,DF1,UTY1,NP2MAX+NPMAX+1,3,IER)
         CALL SPL1DI0(TX1,UTY1,UTY10,NP2MAX+NPMAX+1,IER)
         CALL SPL1DI(PMAX2,PSUM,TX1,UTY1,UTY10,NP2MAX+NPMAX+1,IER)

         DO NP=1,NPMAX
            RGAMA=SQRT(1.D0+PM(NP,NSBA)**2*TMC2FP0)
            ptatb=PM(NP,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM4,TX1,UTY1,UTY10,NPMAX+NP2MAX+1,IER)
               RYABM(NP,L,NI,NA)=(PSUM-SUM4)*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RYABM(NP,L,NI,NA)=0.D0
            ENDIF
         END DO
         DO NPG=1,NPMAX+1
            RGAMA=SQRT(1.D0+PG(NPG,NSBA)**2*TMC2FP0)
            ptatb=PG(NPG,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM5,TX1,UTY1,UTY10,NPMAX+NP2MAX+1,IER)
               RYABG(NPG,L,NI,NA)=(PSUM-SUM5)*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RYABG(NPG,L,NI,NA)=0.D0
            ENDIF
         END DO
!        PG2 and PM2
         DO NP=1,NP2MAX
            RGAMA=SQRT(1.D0+PM2(NP,NSBA)**2*TMC2FP0)
            ptatb=PM2(NP,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM4,TX1,UTY1,UTY10,NPMAX+NP2MAX+1,IER)
               RYABM2(NP,L,NI,NA)=(PSUM-SUM4)*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RYABM2(NP,L,NI,NA)=0.D0
            ENDIF
         END DO
         DO NPG=1,NP2MAX+1
            RGAMA=SQRT(1.D0+PG2(NPG,NSBA)**2*TMC2FP0)
            ptatb=PG2(NPG,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM5,TX1,UTY1,UTY10,NPMAX+NP2MAX+1,IER)
               RYABG2(NPG,L,NI,NA)=(PSUM-SUM5)*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RYABG2(NPG,L,NI,NA)=0.D0
            ENDIF
         END DO

      END DO
      END DO
      END DO

      END SUBROUTINE INTEGRATION_RJAB_RYAB_F
! ---------------------------------
      SUBROUTINE INTEGRATION_RJAB_RYAB(NSB,NSA,NR,FPL,RJABG,RJABM,RYABG,RYABM)

      IMPLICIT NONE

      integer,parameter::LNM=5

      real(8),DIMENSION(NPMAX+3,-1:LNM):: FPL

      real(8),DIMENSION(NTHMAX+3):: TX,TY,DF
      real(8),DIMENSION(4,NTHMAX+3):: UTY
      real(8),dimension(NTHMAX+3)::UTY0
      real(8),DIMENSION(NPMAX+3+NP2MAX):: TX1,TY1,DF1,UTY10
      real(8),DIMENSION(4,NPMAX+3+NP2MAX):: UTY1

      real(8),DIMENSION(-2:LLMAX+2, -1:2):: FKLF_J,FKLF_Y
      real(8),DIMENSION(-2:LLMAX+2, 0:2):: RJ_1, RY_1
      real(8),DIMENSION(NPMAX+4, 0:LLMAX, 0:2, -1:2):: RJABM,RJABG 
      real(8),DIMENSION(NPMAX+4, 0:LLMAX, 0:2, -1:2):: RYABM,RYABG

      integer:: NP, NTH, NSA, NSB, L, NR, LLMIN, NI, NA, NNP, NPG, NSBA
      integer:: IER, NS
      real(8):: RGAMH, TMC2FD0, TMC2FP0, SUM1, SUM2, SUM3, SUM4, SUM5
      real(8):: PSUM, PCRIT, RGAMA, RGAMB, RUFP, FACT, FACT2
      real(8):: vtatb, pabbar, ptatb, PMAX2

!
!----- DEFINITION OF LOCAL QUANTITIES -------------
!
      RGAMH=RNUD(NR,NSB,NSA)*SQRT(2.D0)*VTFD(NR,NSB)*AMFP(NSA) &
           /(RNFP0(NSA)*PTFP0(NSA)*1.D20)
      TMC2FD0=(PTFD0(NSB)/(AMFD(NSB)*VC))**2
      TMC2FP0=(PTFP0(NSA)/(AMFP(NSA)*VC))**2
      NSBA=NSB_NSA(NSA)

      vtatb=(AMFD(NSB)*PTFP0(NSA))/(AMFP(NSA)*PTFD0(NSB))
      pabbar=(PTFP0(NSA)*AMFD(NSB))/(PTFD0(NSB)*AMFP(NSA))


      DO NI = 0, 2
      DO NA = 0, 2

      DO L=0,LLMAX
         TX1(1)=0.D0
         TY1(1)=0.D0
         NNP=1
         DO NNP=1,NPMAX
            RGAMB=SQRT(1.D0+PM(NNP,NSB)**2*TMC2FD0)
            RUFP = (PTFD0(NSB)*PM(NNP,NSB))/AMFD(NSB)
            CALL FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)
            TX1(NNP+1)=PM(NNP,NSB)
            TY1(NNP+1)=FPL(NNP,L)*(PM(NNP,NSB)**(2+NI))/RGAMB &
                 *RJ_1(L+NI,NA)

         END DO
         TX1(NPMAX+2)=PMAX(NSB)
         TY1(NPMAX+2)=0.D0
         DF1(1)   = 0.D0
         DF1(NPMAX+2)   = 0.D0
         PMAX2=PMAX(NSB)
         CALL SPL1D(TX1,TY1,DF1,UTY1,NPMAX+2,3,IER)
         CALL SPL1DI0(TX1,UTY1,UTY10,NPMAX+2,IER)
         CALL SPL1DI(PMAX2,PSUM,TX1,UTY1,UTY10,NPMAX+2,IER)

         DO NP=1,NPMAX
            RGAMA=SQRT(1.D0+PM(NP,NSBA)**2*TMC2FP0)
            ptatb=PM(NP,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM2,TX1,UTY1,UTY10,NPMAX+2,IER)
               RJABM(NP,L,NI,NA)=SUM2*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RJABM(NP,L,NI,NA)=PSUM*(PTFD0(NSB)/AMFD(NSB))**NI
            ENDIF
         END DO
         DO NPG=1,NPMAX+1
            RGAMA=SQRT(1.D0+PG(NPG,NSBA)**2*TMC2FP0)
            ptatb=PG(NPG,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM3,TX1,UTY1,UTY10,NPMAX+2,IER)
               RJABG(NPG,L,NI,NA)=SUM3*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RJABG(NPG,L,NI,NA)=PSUM*(PTFD0(NSB)/AMFD(NSB))**NI
            ENDIF
         END DO
      END DO
!-------
      DO L=0,LLMAX
         TX1(1)=0.D0
         TY1(1)=0.D0
         DO NNP=1,NPMAX
            RGAMB=SQRT(1.D0+PM(NNP,NSB)**2*TMC2FD0)
            RUFP = (PTFD0(NSB)*PM(NNP,NSB))/AMFD(NSB)
            CALL FKLF_JY(RUFP,FKLF_J,FKLF_Y,RJ_1,RY_1)
            TX1(NNP+1)=PM(NNP,NSB)
            TY1(NNP+1)=FPL(NNP,L)*(PM(NNP,NSB)**(2+NI))/RGAMB &
                 *RY_1(L-NI,NA)
         END DO
         TX1(NPMAX+2)=PMAX(NSB)
         TY1(NPMAX+2)=0.D0
         DF1(1)   = 0.D0
         DF1(NPMAX+2)   = 0.D0
         PMAX2=PMAX(NSB)
         CALL SPL1D(TX1,TY1,DF1,UTY1,NPMAX+2,3,IER)
         CALL SPL1DI0(TX1,UTY1,UTY10,NPMAX+2,IER)
         CALL SPL1DI(PMAX2,PSUM,TX1,UTY1,UTY10,NPMAX+2,IER)
         DO NP=1,NPMAX
!            PCRIT=(AMFD(NSB)*PTFP0(NSA))/(AMFP(NSA)*PTFD0(NSB))*PM(NP,NSB)
!            PCRIT=(AMFD(NSB)*PTFP0(NSA))/(AMFP(NSA)*PTFD0(NSB))*PM(NP,NSA)
            RGAMA=SQRT(1.D0+PM(NP,NSBA)**2*TMC2FP0)
            ptatb=PM(NP,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM4,TX1,UTY1,UTY10,NPMAX+2,IER)
               RYABM(NP,L,NI,NA)=(PSUM-SUM4)*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RYABM(NP,L,NI,NA)=0.D0
            ENDIF
         END DO
         DO NPG=1,NPMAX+1
!            PCRIT=(AMFD(NSB)*PTFP0(NSA))/(AMFP(NSA)*PTFD0(NSB))*PG(NPG,NSB)
!            PCRIT=(AMFD(NSB)*PTFP0(NSA))/(AMFP(NSA)*PTFD0(NSB))*PG(NPG,NSA)
            RGAMA=SQRT(1.D0+PG(NPG,NSBA)**2*TMC2FP0)
            ptatb=PG(NPG,NSBA)/RGAMA
            PCRIT=SQRT(vtatb**2/(1.D0-TMC2FD0*vtatb**2*ptatb**2))*ptatb
            IF(PCRIT.le.PMAX(NSB)) THEN
               CALL SPL1DI(PCRIT,SUM5,TX1,UTY1,UTY10,NPMAX+2,IER)
               RYABG(NPG,L,NI,NA)=(PSUM-SUM5)*(PTFD0(NSB)/AMFD(NSB))**NI
            ELSE
               RYABG(NPG,L,NI,NA)=0.D0
            ENDIF

         END DO
      END DO
      END DO
      END DO

      END SUBROUTINE INTEGRATION_RJAB_RYAB

      END MODULE fpcalcnr

